//
//  Channel.cpp
//  e_bash
//
//  Created by Arnaud Blanchard on 29/09/2019.
//

#include "Channel.hpp"
#include "blc_channel.h"
#include "string"
#include <vector>
#include <vte/vte.h>
#include <thread>


using namespace Gtk;
using  namespace std;

struct Process{
    pid_t pid;
    
    char  **argv;
    string name;
    string program_name;
    string channel;
    
    void run();
    void watch();
};

void Process::watch(){
    char pipe_buffer[PIPE_SIZE];
    ssize_t pipe_read_nb=0, pipe_buffer_writen_nb=0;
    int fd_max, status;
    ssize_t size=-1, written_nb, read_nb;
    fd_set fd_read_set, fd_write_set;
    
    fd_max=MAX(stdout_fileno, stderr_fileno);
  //  if (input_process) fd_max=MAX(fd_max, input_process->stdout_fileno);
  //  fd_max=MAX(fd_max, stdin_fileno);
    
    do
    {
        size=0;
        FD_ZERO(&fd_read_set);
      //  FD_ZERO(&fd_write_set);
        
        //if (input_process) FD_SET(input_process->stdout_fileno, &fd_read_set);
        FD_SET(stdout_fileno, &fd_read_set);
        FD_SET(stderr_fileno, &fd_read_set);
      //  if (stdin_fileno!=-1 && pipe_read_nb) FD_SET(stdin_fileno, &fd_write_set);
        
        SYSTEM_ERROR_CHECK(::select(fd_max+1, &fd_read_set, NULL, NULL, NULL), -1, "process: '%s' '%s'", name, program->name);
        
   /*     if (stdin_fileno!=-1 && pipe_read_nb && FD_ISSET(stdin_fileno, &fd_write_set)){ //something to write and input ready;
            SYSTEM_ERROR_CHECK(written_nb=write(stdin_fileno, &pipe_buffer[pipe_buffer_writen_nb], pipe_read_nb-pipe_buffer_writen_nb),-1, "pipe_buffer_writen_nb '%ld', pipe_read_nb '%ld'", pipe_buffer_writen_nb, pipe_read_nb);
            SYSTEM_ERROR_CHECK(written_nb=write(STDERR_FILENO, &pipe_buffer[pipe_buffer_writen_nb], pipe_read_nb-pipe_buffer_writen_nb),-1, "pipe_buffer_writen_nb '%ld', pipe_read_nb '%ld'", pipe_buffer_writen_nb, pipe_read_nb);
            
            pipe_buffer_writen_nb+=written_nb;
            size+=written_nb;
        }
        
        if (input_process && FD_ISSET(input_process->stdout_fileno, &fd_read_set)){
            SYSTEM_ERROR_CHECK(read_nb=read(input_process->stdout_fileno, &pipe_buffer[pipe_read_nb], sizeof(pipe_buffer)-pipe_read_nb), -1, "input pipe");
            pipe_read_nb+=read_nb;
            size+=read_nb;
        }
        
        if (pipe_read_nb && pipe_buffer_writen_nb==pipe_read_nb){ //Everything has been written
            pipe_buffer_writen_nb=0;
            pipe_read_nb=0;
        }*/
        
        if (FD_ISSET(stdout_fileno, &fd_read_set)){
            SYSTEM_ERROR_CHECK(size=read(stdout_fileno, pipe_buffer, sizeof(pipe_buffer)), -1, "stdout");
            if (output_process) SYSTEM_ERROR_CHECK(write(next_process_pipe[1], pipe_buffer, size), -1, "next_process_pipe");
            buffer_to_vte_terminal(pipe_buffer, size, stdout_terminal);
        }
        
        if (FD_ISSET(stderr_fileno, &fd_read_set)){
            SYSTEM_ERROR_CHECK(size=read(stderr_fileno, pipe_buffer, sizeof(pipe_buffer)), -1, "stderr");
            buffer_to_vte_terminal(pipe_buffer, size, stderr_terminal);
        }
    }
    while(size!=0);
    
    close(stdout_fileno);
    close(stderr_fileno);
    
    waitpid(pid, &status, 0);
    pid=-1;
    
    g_signal_handler_disconnect(G_OBJECT(stderr_terminal), commit_handler);
    
    // if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(err_toggle_button))) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(err_toggle_button), false);
    
    gdk_threads_add_idle (thread_safe_end_process, this);
}

void Process_old::run(){
    int stdin_pipe[2], stderr_pipe[2], stdout_pipe[2];
 
    SYSTEM_ERROR_CHECK(pipe(stdin_pipe), -1, NULL);
    SYSTEM_ERROR_CHECK(pipe(stdout_pipe), -1, NULL);
    SYSTEM_ERROR_CHECK(pipe(stderr_pipe), -1, NULL);
   
    pid=fork();
    
    if (pid==0){
        /*Connection to virtual termainals*/
        SYSTEM_ERROR_RETRY_ON_SPECIFIC_ERRNO(dup2(stdin_pipe[0] , STDIN_FILENO ), -1, EINTR, NULL);
        SYSTEM_ERROR_RETRY_ON_SPECIFIC_ERRNO(dup2(stdout_pipe[1], STDOUT_FILENO), -1, EINTR, NULL);
        SYSTEM_ERROR_RETRY_ON_SPECIFIC_ERRNO(dup2(stderr_pipe[1], STDERR_FILENO), -1, EINTR, NULL);
     
        blc_close_pipe(stdin_pipe);
        blc_close_pipe(stdout_pipe);
        blc_close_pipe(stderr_pipe);
        SYSTEM_ERROR_CHECK(execvp(program_name.data(), argv), -1, "Executing  program '%s'",  program_name.data());
    }
    close(stdin_pipe[0]);
    close(stdout_pipe[1]);
    close(stderr_pipe[1]);
    
    thread thread([](){
        watch();
    });
    
    //commit_handler=g_signal_connect(G_OBJECT(stderr_terminal), "commit", G_CALLBACK(input_cp), this);
}


struct ModelColumns : public TreeModel::ColumnRecord{
    Gtk::TreeModelColumn<string> name, type, format, dimensions, icon;
    
    ModelColumns(){
        add(name);
        add(type);
        add(format);
        add(dimensions);
        add(icon);
    }
    
    void add_channel( Glib::RefPtr<Gtk::ListStore>  &list, blc_channel *channel){
        uint32_t type_str, format_str;
        char dims_str[256];
        
        auto row = *(list->append()); //* is because it is an iterator and we want the content of the ref.
        row[name] = channel->name;
        row[type] = string(UINT32_TO_STRING(type_str, channel->type), 4);
        row[format] = string(UINT32_TO_STRING(format_str, channel->format), 4);
        channel->sprint_dims(dims_str, 256);
        row[dimensions] = dims_str;
        row[icon] =  Gtk::Stock::YES.id; //dialog-information";
    }
}m_Columns;

static void refresh_channels(void* user_data){
    
    auto channel_widget = (ChannelWidget *)user_data;
    Glib::signal_idle().connect([&channel_widget](){ //important to use an idle otherwise Thread problems
        channel_widget->refresh_channel_list();
        return false;
    });
}

ChannelWidget::ChannelWidget(){
    Gtk::CellRendererPixbuf     cellRendererPixBuf;
    
    list_store = Gtk::ListStore::create(m_Columns);
    set_model(list_store);
    
    append_column("Name", m_Columns.name);
    append_column("Type", m_Columns.type);
    append_column("Format", m_Columns.format);
    append_column("Dimensions", m_Columns.dimensions);
    
    int numcols = append_column("image ", cellRendererPixBuf);
    get_column(numcols-1)->add_attribute(cellRendererPixBuf, "stock-id",  m_Columns.icon);
    
    refresh_channel_list();
    blc_channel_check_for_event(refresh_channels, this);
    show_all_children();
     
    signal_row_activated().connect([this](const TreeModel::Path& path, TreeViewColumn* column){
        vector <char*> argv_vec;
        Process *process = new Process();
        Gtk::TreeIter iter=this->list_store->get_iter(path);
        Gtk::TreeModel::Row row = *iter;
        
        process->program_name="o_gnuplot";
        process->name=process->program_name;
        process->channel=((string)row[m_Columns.name]).data();
        
        fprintf(stderr, "Row %s\n", ((string)row[m_Columns.name]).data());
        
        argv_vec.emplace_back((char*)process->program_name.data());
        argv_vec.emplace_back((char*)process->channel.data());
        argv_vec.emplace_back(nullptr);
        process->argv=argv_vec.data();
        process->run();
        
        return false;
    });
    
    
    signal_button_release_event().connect([](GdkEventButton* event){
        if  (event->button == 3){
            exit(1);
        };
        return false;
    });
}

void ChannelWidget::refresh_channel_list(){
    int channels_nb;
    blc_channel *channel_infos=nullptr;
    channels_nb = blc_channel_get_all_infos(&channel_infos);
    
    list_store->clear();
    for(blc_channel *channel=channel_infos;  channel != channel_infos+channels_nb; channel++){
        m_Columns.add_channel(list_store, channel);
    }
    free(channel_infos);
}
